
IF .f.
  SAVEDEMO.PRG  - P. L. Olympia -  08/08/86

  Demonstrates the use of quick screens in dB3+ using SAVERES4.BIN
        CALL SaveRes4 WITH "Rn"

  where n = 0,1,2,3.

  Requires the following files on the default drive:
       STATES.DBF
       SAVERES4.BIN
ENDI

SET TALK OFF

SET COLOR TO BG
CLEA
@ 06,01 SAY "This is the file SAVEDEMO.PRG.  It shows you how to use SAVERES4.BIN and"
@ 07,01 SAY "at the same time gives you some (hopefully) useful programming techniques"
@ 08,01 SAY "in dBase3+. For example,"
@ 10,01 SAY "1. Screen 1 stores the U.S. State codes from a data base to a screen which"
@ 11,04 SAY "can be flashed at any time that the user needs it. You can use this"
@ 12,04 SAY "approach to build and flash multiple HELP screens."
@ 14,01 SAY "2. Screen 2 shows an animated screen derived from my program DR-ANIM.PRG"
@ 15,04 SAY "(see Data Based Advisor, Sept '86)"
@ 17,01 SAY "The main menu screen was based on a design from WallSoft's UI."
@ 19,01 SAY "Examine the program. Use whatever codes you can use from it so long as you"
@ 20,01 SAY "give credit where credit is due."
@ 22,01 SAY "Press any key to begin (I will build the screens first)"
SET COLOR TO +BG/B
@ 01,12 SAY "ͻ"
@ 02,12 SAY "                                         "
@ 03,12 SAY "                                         "
@ 04,12 SAY "ͼ"
SET COLOR TO +GR/B
@ 02,13 SAY "   Welcome to the SAVERES4 Demo Program  "
@ 03,13 SAY "       P. L. Olympia, Darwin BBS         "

 SET CONS OFF
 WAIT
 SET CONS ON
SET COLOR TO W/ , /W
 CLEA

 IF .NOT. (FILE('STATES.DBF') .AND. FILE('SAVERES4.BIN'))
    ? CHR(7)+"File STATES.DBF and/or SAVERES4.BIN missing. Aborting'
    RETU
 ENDI

*Load the bin file
  LOAD SaveRes4.BIN

USE states
? 'Building screens ... hang on ...'

* Create screen 1  (State Codes Reference screen)
  SET INTE OFF
  SKIP                              && move pointer
  row = 1
  counter = 1
  colstr='012651'                   && column starts
  GO TOP
  CLEA
  DO WHIL .NOT. EOF()
     col = VAL(SUBS(colstr,counter*2-1,2))
     @ row,col SAY st
     @ row,col+4 SAY state

*          increment
     skip
     counter = IIF(counter=3,1,counter+1)
     row = IIF(counter=1,row+1,row)         && bump up row if past 3rd column
  ENDD

*         Now save the screen to screen 0
  CALL SaveRes4 WITH "S1"

  SET INTE ON

* ----------- Create Screen 2  from DR-ANIM.PRG, dr dBase Column #2------
CLEA
SET COLO TO GR

@  1,16 SAY ""
@  2,16 SAY "                              ۰"
@  3,16 SAY "  This is screen 2 of this    ۰"
@  4,16 SAY "    SAVERES4 demo program     ۰"
@  5,16 SAY "                              ۰"
@  6,16 SAY "  This screen came from the   ۰"
@  7,16 SAY "  pgm DR-ANIM.PRG by -p.o.-   ۰"
@  8,16 SAY "                              ۰"
@  9,16 SAY "                              ۰鰰"
@ 10,16 SAY "                              ۰"
@ 11,16 SAY "                              ۰鰰"
@ 12,16 SAY "                              ۰"
@ 13,16 SAY ""
@ 14,25 SAY "۱             ۱"
@ 15,4 SAY ""
@ 15,59 SAY ""
@ 16,4 SAY "Ŀ"
@ 16,59 SAY "Ŀ"
@ 17,4 SAY "۲۳      Ŀ     "
@ 17,67 SAY ""
@ 18,4 SAY "۲Ĵ DSI Ĵ"
@ 18,67 SAY ""
@ 19,4 SAY "۳            "
@ 19,67 SAY ""
@ 20,4 SAY "          "
@ 20,59 SAY ""
@ 21,4 SAY ""
@ 21,59 SAY ""

* Store the screen
Call SaveRes4 WITH "S2"
CLEA

*------- Screen 0 ----- Menu portion

  SET COLOR TO +W/ 
  CLEAR
  @ 05,37 SAY ""
  @ 06,08 SAY "Ŀ"
  @ 07,08 SAY "                                                       "
  @ 08,37 SAY ""
  @ 09,37 SAY ""
  @ 10,37 SAY ""
  @ 11,37 SAY ""
  SET COLOR TO +W/G
  @ 08,00 SAY "       1         "
  @ 09,00 SAY "    Screen 1     "
  @ 10,00 SAY "   (State Codes) "
  SET COLOR TO +W/B
  @ 08,58 SAY "       2        "
  @ 09,58 SAY "    Screen 2    "
  @ 10,58 SAY "    (UI Art)    "
  SET COLOR TO +W/R
  @ 12,31 SAY "             "
  @ 13,31 SAY "    QUIT     "
  @ 14,31 SAY "             "
  SET COLOR TO +W/G
  @ 02,28 SAY "Ŀ"
  @ 03,28 SAY " SAVERES4 DEMO     "
  @ 04,28 SAY ""
  
* Store screen
  CALL SaveRes4 WITH "S0"

  CLEA

*** main loop : display menu, then do chosen option ***
DO WHILE .T.

  *** OPTKEYS is a string containing all option triggers ***
  OPTKEYS = "12Q"
  *** NUMOPTS is number of menu options, used to control wrap-around ***
  NUMOPTS = 3

*     Show Menu
  CLEA
  CALL SaveRes4 WITH "R0"
  SET COLOR TO +W/R

  *** pre-set choice and key so to first option is 'chosen' initially ***
  CHOICE = NUMOPTS
  KEY = ' '
  *** key input loop ***
  DO WHILE LEN(KEY) <> 0

    *** if an option trigger was typed, set choice and exit ***
    IF AT(UPPER(KEY), OPTKEYS) > 0
      CHOICE = AT(UPPER(KEY),OPTKEYS)
      EXIT
    ENDIF

    *** otherwise, increment choice ***
    IF CHOICE = NUMOPTS
      CHOICE = 1
    ELSE
      CHOICE = CHOICE + 1
    ENDIF


    *** wait for key input ***
*   SET CONSOLE OFF
*   WAIT "" TO KEY
*   SET CONSOLE ON
    @ 22, 10 SAY 'Choose 1,2 or Q' GET key
    READ

  ENDDO

  *** action ***
  DO CASE
    CASE CHOICE = 1
      CLEA
      CALL SaveRes4 WITH "R1"
      SET CONSOLE OFF
      WAIT "" TO KY
      SET CONSOLE ON
      
    CASE CHOICE = 2
      CLEA
      CALL SaveRes4 WITH "R2"
      mline=23
      SET COLO to BG+
      string = ' From Data Based Advisor ...    Welcome to Dr. dBASE   '
      row=11
      col=19
      wide = 25
      I=1
      DO WHIL I < LEN(string)-wide
        @ row,col SAY SUBS(string,I,wide)
        I=I+1
      ENDDO
      SET CONS OFF
      WAIT
      SET CONS ON
      SET COLO TO GR
      
    CASE CHOICE = 3
      SET COLO TO GR
      CLEA
  ? "Hope you learned something from this demo and the source codes provided"
    ? "-p.o.-  301-251-9206, Data"
    return
      
  ENDCASE

ENDDO


